deprecations:
  - feature_name: "Offset pagination limit of 10,000 for /projects endpoint"
    due: April 22, 2020
    reporter: joshlambert
    issue_url: 'https://gitlab.com/gitlab-org/gitlab/issues/34565'
    documentation_link: 'https://docs.gitlab.com/ee/api/#keyset-based-pagination'
    description: |
      An offset-based pagination limit of `10,000` will be applied on
      GitLab.com, and by default on self-managed instances, to the `/projects`
      API endpoint in GitLab 12.10. Integrations which make API calls with
      offsets above `10,000` will need to switch to a [keyset-based pagination
      method](https://docs.gitlab.com/ee/api/#keyset-based-pagination), which
      will offer significantly improved response times and reduced load on the
      GitLab server. Self-managed instances will be able to customize the limit
      to a desired value.

      To provide the optimized performance, keyset-based pagination only offers
      ordering based on project `id`. Use cases which require more flexible
      ordering options can continue to use offset-based pagination, provided the
      offsets remain below the limit. If use cases require flexible ordering
      options with deep offsets, we recommend sorting client-side.